﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Threading;
using System.Windows.Media.Imaging;

namespace LiveCoding0827
{
    public partial class MainPage : PhoneApplicationPage
    {
        public class Timetag
        {
            public ulong Begin { get; set; }
            public ulong End { get; set; }
            public string Text { get; set; }
        }

        public List<Timetag> time { get; set; }

        Timer timer;
        Timer slideshow;
        Timetag currentTag;
        int currentIndex;

        string[] images;
        Random rnd;
        // コンストラクター
        public MainPage()
        {
            InitializeComponent();
            rnd = new Random();
            time = new List<Timetag>{
                new Timetag{Begin=5900,  End=12200,Text="白い 吐息 凍える ほっぺた"},
                new Timetag{Begin=12700, End=19200,Text="街路樹も はだかで 寒そうね"},
                new Timetag{Begin=19800, End=26000,Text="冷たい 水に かじかむ お手手"},
                new Timetag{Begin=26500, End=33400,Text="何だか 冬は 物悲しいわね"},
                new Timetag{Begin=33700, End=40000,Text="でも もうすぐ 暖かい春が やってくる"},
                new Timetag{Begin=40400, End=47400,Text="希望に満ちた 明るい春が やってくる"},
                new Timetag{Begin=50700, End=56900,Text="春に なったら きれいな花が咲く"},
                new Timetag{Begin=57400, End=63600,Text="春に なったら うきうきしちゃうわ"},
                new Timetag{Begin=64200, End=70500,Text="ねえ つぼみさん もうちょっと待っててね"},
                new Timetag{Begin=71100, End=78200,Text="春は すぐそこに 届いているから"}
            };
            images = new string[]{"images/pic00.jpg","images/pic01.jpg","images/pic02.jpg","images/pic03.jpg","images/pic04.jpg","images/pic05.jpg","images/pic06.jpg","images/pic07.jpg","images/pic08.jpg","images/pic09.jpg","images/pic10.jpg"};
            currentTag = time[0];
            currentIndex = 0;
            timer = new Timer(TimerProc);
            slideshow = new Timer(SlideshowProc);
            image1.Source = new BitmapImage(new Uri(images[rnd.Next(images.Length)], UriKind.Relative));
        }

        private void SlideshowProc(object o)
        {
            Dispatcher.BeginInvoke(() =>
            {
                if (image1.Opacity == 0)
                {
                    image1.Source = new BitmapImage(new Uri(images[rnd.Next(images.Length)], UriKind.Relative));
                    var anim = new SimpleAnimation<DoubleAnimation, double>()
                    {
                        Duration = TimeSpan.FromMilliseconds(1000),
                        From = 0,
                        To = 1
                    };
                    anim.Begin(image1, Image.OpacityProperty);
                    anim = new SimpleAnimation<DoubleAnimation, double>()
                    {
                        Duration = TimeSpan.FromMilliseconds(1000),
                        From = 1,
                        To = 0
                    };
                    anim.Begin(image2, Image.OpacityProperty);
                }
                else
                {
                    image2.Source = new BitmapImage(new Uri(images[rnd.Next(images.Length)], UriKind.Relative));
                    var anim = new SimpleAnimation<DoubleAnimation, double>()
                    {
                        Duration = TimeSpan.FromMilliseconds(1000),
                        From = 1,
                        To = 0
                    };
                    anim.Begin(image1, Image.OpacityProperty);
                    anim = new SimpleAnimation<DoubleAnimation, double>()
                    {
                        Duration = TimeSpan.FromMilliseconds(1000),
                        From = 0,
                        To = 1
                    };
                    anim.Begin(image2, Image.OpacityProperty);
                }
            });
        }

        private void TimerProc(object o)
        {
            Dispatcher.BeginInvoke(() =>
            {
                if (element.Position.TotalMilliseconds > currentTag.Begin)
                {
                    lyrics.Text = currentTag.Text;
                    var anim = new SimpleAnimation<DoubleAnimation, double>()
                    {
                        Duration = TimeSpan.FromMilliseconds(currentTag.End - currentTag.Begin),
                        From = 0,
                        To = 1
                    };
                    anim.Begin(begin1, GradientStop.OffsetProperty);
                    anim = new SimpleAnimation<DoubleAnimation, double>()
                    {
                        Duration = TimeSpan.FromMilliseconds(currentTag.End - currentTag.Begin),
                        From = 0,
                        To = 1
                    };
                    anim.Begin(begin2, GradientStop.OffsetProperty);
                    if (currentIndex < time.Count-1)
                    {
                        currentIndex++;
                        currentTag = time[currentIndex];
                    }
                }
            });
        }

        private void _CurrentStateChanged(object sender, RoutedEventArgs e)
        {
            
        }

        private void ApplicationBarIconButton_Click(object sender, EventArgs e)
        {
            element.Play();
            timer.Change(0, 50);
            slideshow.Change(0, 3000);
            lyrics.Text = " ";
        }

        private void ApplicationBarIconButton_Click_1(object sender, EventArgs e)
        {
            element.Stop();
            element.Position = TimeSpan.FromMilliseconds(0);
            timer.Change(Timeout.Infinite, Timeout.Infinite);
            slideshow.Change(Timeout.Infinite, Timeout.Infinite);
            currentIndex = 0;
        }
    }
}